gosub Main
end

Main:
  WallOnRight = -1
  WallOnLeft = 1
  gosub Rooms
  call DrawX(310,100,10)
  call DrawX(400,385,10)
  gosub InitRobot
  for i=1 to 5
    delay 1000 // wait for button press
    gosub GoToDining
    delay 1000 // wait for button press
    gosub GoToKitchen
  next
end

sub DrawX(x,y,s)
  setcolor RED
  linewidth 5
  line x-s,y-s,x+s,y+s
  line x+s,y-s,x-s,y+s
return

Sub GoThroughDoor(Wall)
  rforward 60
  rturn -90*Wall
  rForward 70
return

GoToDining:
  rPen DOWN, RED
  rTurn 180
  while rRange()>10
    rforward 1
  wend
  rTurn -90
  call FollowWall(WallOnRight,500,30,DoorFound)
  call GoThroughDoor(WallOnRight)
  while rRange()>10
    rforward 1
  wend
  rTurn 90
  call FollowWall(WallOnLeft,500,30,DoorFound)
  call GoThroughDoor(WallOnLeft)
  rTurn -90
  rForward 50
  call FollowWall(WallOnLeft,110,30,DoorFound)
  rTurn 90
  while rRange()<50
    // beep or something appropriate
  wend
  rForward 50
return

GoToKitchen:
  rPen DOWN, GREEN
  rTurn 180
  while rRange()>10
   rforward 1
  wend
  rTurn -90
  call FollowWall(WallOnRight,150,30,DoorFound)
  call GoThroughDoor(WallOnRight)
  while rRange()>10
    rforward 1
  wend
  rTurn 90
  call FollowWall(WallOnLeft,250,30,DoorFound)
  call GoThroughDoor(WallOnLeft)
  rTurn -90
  rForward 50
  call FollowWall(WallOnLeft,180,30,DoorFound)
  rTurn 90
  rForward 65
return

Rooms:
  LineWidth 2
  rectangle 620,40,700,200
  rectangle 30,120,260,200
  rectangle 45,135,105,175
  rectangle 370,20,550,100
  xyString 130,150,"Counter/Sink"
  xyString 405,50,"Prep Counter"
  xyText 130,50,"KITCHEN",,20
  xyText 475,520,"DINING",,20
  call Table(200,400,40)
  call Table4(335,510,60)
  call Table4(550,410,60)
  LineWidth 10
  line 0,200,500,200
  line 580,200,700,200
  line 700,0,700,500
  line 100,500,100,300
  lineto 200,300
  line 280,300,700,300  
return

InitRobot:
  rLocate 310,100
  LineWidth 2
  rInvisible RED,GREEN
  rSlip 5
return

sub Table4(x,y,r)
  call MyCircle (x,y-.8*r,r/2)
  call MyCircle (x,y+.8*r,r/2)
  call Table(x,y,r)
return

sub Table(x,y,r)
  call MyCircle (x-.8*r,y,r/2)
  call MyCircle (x+.8*r,y,r/2)
  call MyCircle (x,y,r)
return

sub MyCircle(x,y,r)
  circle x-r,y-r,x+r,y+r
return

Sub FollowWall(Wall,Amount,Dist,&DoorFound)
  DoorFound = False
  for i=1 to Amount/2
    // measure distance
    d= rRange(-80*Wall)
    // check for doorway
    if d-Dist>15 then DoorFound=True\break  
    if d>Dist then rTurn -1*Wall
    if d<Dist then rTurn Wall
    rForward 2
  next
return

